import { openBlock, createBlock } from 'vue';

var script = {
  props: {
    sitekey: String
  },
  methods: {
    execute() {
      window.grecaptcha.execute(0);
    },

    reset() {
      window.grecaptcha.reset(0);
    },

    inject() {
      const plugin = document.createElement("script");
      plugin.setAttribute("src", "https://www.google.com/recaptcha/enterprise.js");
      plugin.async = true;
      plugin.defer = true;
      document.head.appendChild(plugin);
    },

    render() {
      if (window.grecaptcha) {
        this.widgetId = window.grecaptcha.enterprise.render("g-recaptcha", {
          sitekey: this.siteKey,
          // the callback executed when the user solve the recaptcha
          callback: response => {
            // emit an event called verify with the response as payload
            this.$emit("verify", response); // reset the recaptcha widget so you can execute it again

            this.reset();
          }
        });
      }
    }

  },

  mounted() {
    this.inject();
    this.render();
  }

};

function render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("div", {
    id: "g-recaptcha",
    class: "g-recaptcha",
    "data-sitekey": $props.sitekey
  }, null, 8, ["data-sitekey"]);
}

script.render = render;

// Import vue component
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),

var entry_esm = /*#__PURE__*/(() => {
  // Get component instance
  const installable = script; // Attach install function executed by Vue.use()

  installable.install = app => {
    app.component('VueRecaptchaEnterprise', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;

export default entry_esm;
